#!/usr/bin/perl

use POSIX;
use IO::Socket;
use IO::Select;
use Socket;
use Fcntl;
use Tie::RefHash;



$debug = 1;
$port = 4567;
$iptables = "/sbin/iptables";
$rule_insert_index = 1;

$| = 1;
print "starting manad..\n";

#    
%CLRULE = ();
%RUL_NUMBERS = ();
%DEL_RULES = ();
%CONTRACT_INDEX = ();


#    
%inbuffer	= ();
%outbuffer	= ();
%ready		= ();

tie %ready, 'Tie::RefHash';

#  
$server = IO::Socket::INET->new( LocalPort => $port, Listen => 10 )
	or die "Can`t make server socket: $@\n";

nonblock( $server );

$SIG{INT} = sub { $server->close(); exit( 0 ); };

$select = IO::Select->new( $server );

$pid = getpid();

open(FILE, ">/var/run/manad.pid");
print FILE $pid;
close(FILE);

#   root   
# chroot( $homedir ) or die "Couldn`t chroot to $homedir: $!\n";

#  :  /,  ,
#    

while( 1 )
{
	my $client;
	my $rv;
	my $data;

	#       

	#   -    ?	
	foreach $client ( $select->can_read( 1 ) )
	{
		if ( $client == $server )
		{
			#   
			$client = $server->accept();
			$select->add( $client );
			nonblock( $client );
		}		
		else
		{
			#  
			$data = '';
			$rv = $client->recv( $data, POSIX::BUFSIZ, 0 );

			unless( defined( $rv ) && length $data )
			{
				#     ,   
				delete $inbuffer{$client};
				delete $outbuffer{$client};
				delete $ready{$client};

				$select->remove( $client );
				close $client;
				next;
			}

			$inbuffer{$client} .= $data;

			# ,         
			#     ,  .   - 
			#  $ready{$client} ,  .
			while( $inbuffer{$client} =~ s/(.*\n)// ) { push( @{$ready{$client}}, $1 ) }
		}
	}
	
	#      ?
	foreach $client ( keys %ready ) { handle( $client ); }

	#  ?
	foreach $client ( $select->can_write( 1 ) )
	{
		#   ,    
		next unless $outbuffer{$client};

		$rv = $client->send( $outbuffer{$client}, 0 );
		unless( defined $rv )
		{
			# ,   
			warn "I was told I could write? but I can`t.\n";
			next;
		}
		if ( $rv == length $outbuffer{$client} || $! == POSIX::EWOULDBLOCK )
		{
			substr( $outbuffer{$client}, 0, $rv ) = '';
			delete $outbuffer{$client} unless length $outbuffer{$client};
		}
		else
		{
			#        - .
			#     .
			delete $inbuffer{$client};
			delete $outbuffer{$client};
			delete $ready{$client};

			$select->remove($client);
			close($client);
			next;
		}
	}
}

# handle( $socket )    
#   $client
sub handle
{
	#    $ready{$client}
	#    $outbuffer{$client}
	my $client = shift;
	my $request;

	foreach $request ( @{$ready{$client}} )
	{

		print "\nrequest =".$request."\n" if ( $debug == 1 );
		
		if ( $request =~ /^test/ )
		{
			my $open_client = "";
			foreach my $kod ( keys %CLRULE )
				{ $open_client .= $open_client eq "" ? $kod : " ".$kod; }
			$outbuffer{$client} .= $open_client."\n";
		}
		elsif ( $request =~ /^add\t([0-9]+)\t(.*)/ )
		{
			my ($kod, $rule) = ($1, $2);
			&delete_rule( $kod, $rule ) if ( exists $CLRULE{$kod} );
			&add_rule( $kod, $rule ) if ( !exists $CLRULE{$kod} );
		}
		elsif ( $request =~ /^remove\t([0-9]+)\t(.*)/ )
		{
			my $kod = $1;			
			&delete_rule( $kod ) if ( exists $CLRULE{$1} );
		}
	}

	delete $ready{$client};
}

# nonblock( $socket )     
sub nonblock
{
	my $socket = shift;
	my $flags;

	$flags = fcntl( $socket, F_GETFL, 0 )
		or die "Can`t get flags for socket: $!\n";
	fcntl( $socket, F_SETFL, $flags | O_NONBLOCK )
		or die "Can`t make socket nonblocking: $!\n";
}

sub add_rule
{
	my $kod = $_[0];
	my $rule = $_[1];
	

	
	#    {N0} 

	while ( $rule =~ /\[N([0-9]+)\]/ )
	{
		my $n = $1;
		my $i = 2;	

		#    
		while( 1 )
		{
			$i++;
			last if ( !exists $RUL_NUMBERS{$i} );
		}
		$RUL_NUMBERS{$i} = "1";
		$rule =~ s/\[N$n\]/$i/g;
		

		$CONTRACT_INDEX{$kod}{$i}=$i;

	}
	
	

	$CLRULE{$kod} = $rule;
	
	
	#  
	my $add_rule = $rule;
	$add_rule =~ s/\[OPEN\]((.|\n)+)\[\/OPEN\]((.|\n)*)/${1}/;
	

	print "commands:\n" if ( $debug == 1 );	
	my @rules = split( /\|/, $add_rule );
        foreach $line ( @rules )
        {
	        print "$line\n" if ( $debug == 1 );
	        $err = `$line`;

        }
	#      
	my $del_rule = $rule;
	$del_rule =~ s/(?:(.|\n?:)*)\[CLOSE\]((.|\n)+)\[\/CLOSE\]((.|\n)*)/${2}/;
	print "\ndelete =".$del_rule."\n" if ( $debug == 1 );
	$DEL_RULES{$kod}=$del_rule

#	DEL_RULES

}

sub delete_rule
{
	my $kod = $_[0];


	my $rule = $DEL_RULES{$kod};
       	my @rules = split( /\|/, $rule );


	print "commands:\n" if ( $debug == 1 );	        
	foreach $line ( @rules )
        {
	        print "$line\n" if ( $debug == 1 );
	        $err = `$line`;

        }

	delete $DEL_RULES{$kod};	
	delete $CLRULE{$kod};


	foreach my $idx ( keys %{$CONTRACT_INDEX{$kod}} )
	{
	    print "\n deleting rules with idx=".$CONTRACT_INDEX{$kod}{$idx}."\n";		
	    delete $RUL_NUMBERS{$CONTRACT_INDEX{$kod}{$idx}}; 	       	
	}	

	
	delete $CONTRACT_INDEX{$kod};
}
